/***************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto                                  *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/

#ifndef KITATHREADTABWIDGET_H
#define KITATHREADTABWIDGET_H

#include <qtabwidget.h>
#include <qtabbar.h>
#include <kparts/browserextension.h>
#include <kxmlguiclient.h>

class KitaThreadPart;
class KitaThreadView;
class KURL;

namespace Kita
{
    class Thread;
}

/**
@author Hideki Ikemoto
*/
class KitaThreadTabWidget : public QTabWidget , public KXMLGUIClient
{
    Q_OBJECT

	KXMLGUIClient * m_oldXmlClient;

public:
    KitaThreadTabWidget( QWidget* parent = 0, const char* name = 0, WFlags f = 0 );
    ~KitaThreadTabWidget();

public slots:
    void showThread( const QString& datURL, bool withNewTab );
    void deleteView( KitaThreadView* );
    void reloadThread();
    void focusSearchCombo();
    void slotCurrentChanged( QWidget* );
    void closeCurrentTab();
    
private:
    void setupActions();
    void connectSignals( KitaThreadView* );
    KitaThreadView* createView();
    QPtrList<KitaThreadView> m_viewList;
    KitaThreadView* findView( const QString& threadURL );

private slots:
    void slotThread( const Kita::Thread* );

signals:
    void signalChangeStatusbar( const QString& );
    void sigHideSubject();
};

class KitaThreadTabBar : public QTabBar
{
    Q_OBJECT

public:
    KitaThreadTabBar( QWidget* parent = 0, const char* name = 0 );
    ~KitaThreadTabBar();

protected:
    virtual void contextMenuEvent( QContextMenuEvent* e );

signals:
    void deleteMenuSelected( KitaThreadView* );
};

#endif
