/***************************************************************************
 *   Copyright (C) 2004 by Kita Developers                                 *
 *   ikemo@users.sourceforge.jp                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef KITASIGNALCOLLECTION_H
#define KITASIGNALCOLLECTION_H

#include <kparts/browserextension.h>

#include <qobject.h>

namespace Kita
{
    class Thread;

    /**
    @author Hideki Ikemoto
    */
    class SignalCollection : public QObject
    {
        Q_OBJECT
        
        static SignalCollection* instance;
        
        SignalCollection();
        ~SignalCollection();
    public:
        static SignalCollection* getInstance();
    
    signals:
        void openURLRequest( const KURL& url, const KParts::URLArgs& args = KParts::URLArgs() );
        void signalChangeStatusbar( const QString& );
        void writeSucceeded();
        void bookmarked( const QString& datURL, bool on );
        void showThreadCompleted( const KURL& threadUrl );
        void signalThread( const Kita::Thread* );
        void openBoardRequested( const QString& boardURL, bool withNewTab );
    };

}

#endif
